mOutStrD MACRO a_sz:VARARG
	LOCAL sz
	IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz,0
.CODE
	pushad
	invoke	OutputDebugString,offset sz
	popad
	ENDIF
ENDM
mOS MACRO a_sz:VARARG			;shorter typing version :P
	LOCAL sz
	IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz,0
.CODE
	pushad
	invoke	OutputDebugString,offset sz
	popad
	ENDIF
ENDM

mOutStr MACRO a_psz
	IFDEF	DEBUG_BUILD
	pushad
	invoke	OutputDebugStringA,a_psz
	popad
	ENDIF
ENDM

.DATA?
	sz_dbg_ss	db	512 dup (?)
.CODE

mOutSS MACRO a_off_sz,a_sz:VARARG
	LOCAL sz
IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz,0
.CODE
	pushad
	invoke	Str_Copy,offset sz,offset sz_dbg_ss
	add	eax,offset sz_dbg_ss
	invoke	Str_Copy,a_off_sz,eax
	invoke	OutputDebugString,offset sz_dbg_ss
	popad
ENDIF

ENDM

mOutSS2 MACRO a_off_sz,a_sz:VARARG
	LOCAL sz
IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz,0
.CODE
	pushad
	invoke	Str_Copy,a_off_sz,offset sz_dbg_ss
	add	eax,offset sz_dbg_ss
	invoke	Str_Copy,offset sz,eax
	invoke	OutputDebugString,offset sz_dbg_ss
	popad
ENDIF

ENDM

mOutSS2r MACRO a_off_sz,a_sz:VARARG
	LOCAL sz
IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz,0
.CODE
	pushad
	invoke	Str_Copy,offset sz,offset sz_dbg_ss
	add	eax,offset sz_dbg_ss
	invoke	Str_Copy,a_off_sz,eax
	invoke	OutputDebugString,offset sz_dbg_ss
	popad
ENDIF

ENDM


OutStr PROC	a_lpsz:DWORD

IFDEF	DEBUG_BUILD
	pushad
	invoke	OutputDebugStringA,[a_lpsz]
	popad
ENDIF

ret
OutStr ENDP


mOutVal MACRO a_val,a_fmt:=<0>
IFDEF	DEBUG_BUILD
	pushad
	invoke	DWtoAscii,a_val,offset szValue,a_fmt
	invoke	OutStr,offset szValue
	popad
ENDIF
ENDM

mOutValD MACRO a_val
IFDEF	DEBUG_BUILD
	pushad
	invoke	DWtoAscii,a_val,offset szValue,FMT_LD
	invoke	OutStr,offset szValue
	popad
ENDIF
ENDM

mOutValH MACRO a_val
IFDEF	DEBUG_BUILD
	pushad
	invoke	DWtoAscii,a_val,offset szValue,FMT_LX
	invoke	OutStr,offset szValue
	popad
ENDIF
ENDM

mOutSVH MACRO a_val_hex,a_sz:VARARG
	LOCAL sz,sz_val
IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz
	sz_val	db	10 dup (0)
.CODE
	pushad
	invoke	DWtoAscii,a_val_hex,offset sz_val,FMT_LX
	invoke	OutputDebugString,offset sz
	popad
ENDIF
ENDM

mOutSVD MACRO a_val_dec,a_sz:VARARG
	LOCAL sz,sz_val
IFDEF	DEBUG_BUILD
.DATA
	sz	db	a_sz
	sz_val	db	10 dup (0)
.CODE
	pushad
	invoke	DWtoAscii,a_val_dec,offset sz_val,FMT_LD
	invoke	OutputDebugString,offset sz
	popad
ENDIF
ENDM

OutVal PROC	a_value:DWORD,a_format:DWORD
IFDEF	DEBUG_BUILD
	pushad
	invoke	DWtoAscii,[a_value],offset szValue,[a_format]
	invoke	OutStr,offset szValue
	popad
ENDIF
ret
OutVal ENDP


