
;****************************************************
;
; 	UTIL FUNCTIONS 
;	for dword to ASCII conversion
;
;****************************************************

	wsprintfA PROTO C :DWORD
	wsprintf equ <wsprintfA>
.data
FMT_LU		EQU	0
FMT_LX		EQU	1
FMT_LD		EQU	2
FMT_LDP2	EQU	3
	szValue		db	32 dup(0)
	format_lu	db	"%lu",0		;long unsigned
	format_lx	db	"%lx",0		;long hexa
	format_ld	db	"%ld",0		;long signed decimal
	format_ldp2	db	"%.2ld",0	;long signed decimal padded with 2 zeros
	
;jump table
formats_wsprintf	\
	dd	offset format_lu
	dd	offset format_lx
	dd	offset format_ld
	dd	offset format_ldp2
	
ALIGN	4
.code

DWtoAscii PROC USES ECX a_value:DWORD,a_lp_buffer:DWORD,a_format:DWORD
	LOCAL	l_lp_format:DWORD
	
	mov	eax,[a_format]
	mov	eax,[formats_wsprintf+eax*4]
	
	push	[a_value]
	push	eax
	push	[a_lp_buffer]
	
	call	wsprintf
	add	esp,12
	
ret
DWtoAscii ENDP


